/*
    A singly linked (generic) node class for use in the singly linked list class.
*/

public class Node<T>
{
   private T element;
   private Node<T> next;

   // Default constructor
   public Node()
   {
      this.element = null;
      next = null;
   }

   public Node(T element, Node<T> n)
   {
      this.element = element;
      next = n;
   }

   public T getElement()
   {
      return element;
   }

   public Node<T> getNext()
   {
      return next;
   }

   public void setElement(T element)
   {
      this.element = element;
   }

   public void setNext(Node<T> next)
   {
      this.next = next;
   }

   public String toString()
   {
      return element.toString();
   }
}