/*
    A (generic) singly linked list class.
*/

public class SLinkedList<T> extends List<T>
{
   protected Node<T> head;

   // Default constructor (empty list)
   public SLinkedList()
   {
      head = null;
      size = 0;
   }

   public void addFirst(T element)
   {
      size++;
      Node<T> first = new Node<T>();
      first.setElement(element);
      first.setNext(head);
      head = first;
      // The last four lines can be combined into a single line
      //head = new Node<T>(element, head);
   }

   public void addLast(T element)
   {
      Node<T> next = head;
      for (int i = 0; i < size-1; i++)  // walk the list
      {
         next = next.getNext();
      }
      next.setNext( new Node<T>(element, null) );
      size++;
   }

   public T removeFirst()
   {
      if( size > 0 )
      {
         size--;
         T temp = head.getElement();
         head = head.getNext();
         return temp;
      }
      else
         return null;
   }

   public T removeLast()
   {
      if( size > 0 )
      {
         Node<T> currentNode = head;
         size--;
         for (int i = 0; i < size-1; i++)  // walk the list
         {
            currentNode = currentNode.getNext();
         }
         T temp = currentNode.getNext().getElement();
         currentNode.setNext(null);
         return temp;
      }
      else
         return null;
   }

   public String toString()
   {
      // walk the list and call toString() on each node
      String temp = "[ ";
      Node<T> currentNode = head;
      for (int i = 0; i < size; i++)
      {
         temp += (currentNode.getElement().toString() + " ");
         currentNode = currentNode.getNext();
      }
      return temp + "]";
   }

}